diff -ur qpopper4.0.8/popper/pop_config.c qpopper4.0.8-log/popper/pop_config.c
--- qpopper4.0.8/popper/pop_config.c	Thu Apr 28 18:46:18 2005
+++ qpopper4.0.8-log/popper/pop_config.c	Thu May 26 20:09:35 2005
@@ -253,6 +253,7 @@
     kCHUNKY_WRITES,         /*    (no flag)     */
     kNO_ATOMIC_OPEN,        /*    (no flag)     */
     kLOG_FACILITY,          /* -y facility      */
+    kLOG_LEVEL,             /*    (no flag)     */
     kLOG_LOGIN,             /*    (no flag)     */
     kMAXBULLS,              /*    (no flag)     */
     kSASL_LOG_LOGIN,        /*    (no flag)     */
@@ -306,6 +307,7 @@
     { "kerberos"                     , CfgBool , CfgResUser, kKERBEROS           },
     { "kerberos-service"             , CfgStr  , CfgResUser, kKERBSERVICE        },
     { "log-facility"                 , CfgMnem , CfgInit   , kLOG_FACILITY       },
+    { "log-level"                    , CfgMnem , CfgResNone, kLOG_LEVEL          },
     { "log-login"                    , CfgStr  , CfgInit   , kLOG_LOGIN          },
     { "mail-command"                 , CfgStr  , CfgResUser, kMAIL_COMMAND       },
     { "mail-lock-check"              , CfgInt  , CfgResNone, kLOCKCHECK          },
@@ -442,6 +444,18 @@
     { NULL              , PopLogMail            }
 };
 
+static mnemonic_map mnem_map_log_level [] =
+{
+    
+    { "priority"        , POP_NOTICE            },
+    { "warning"         , POP_WARNING           },
+    { "notice"          , POP_NOTICE            },
+    { "info"            , POP_INFO              },
+    { "debug"           , POP_DEBUG             },
+
+    { NULL              ,                       }
+};
+
 /* ...pam-session */
 static mnemonic_map mnem_map_pam_session [] =
 {
@@ -463,6 +477,7 @@
     { kTLS_VERSION      , mnem_map_tls_vers       },
     { kCHUNKY_WRITES    , mnem_map_chunky_writes  },
     { kLOG_FACILITY     , mnem_map_log_facility   },
+    { kLOG_LEVEL        , mnem_map_log_level      },
     { kPAM_SESSION      , mnem_map_pam_session    },
 
     { -1                , NULL                     }
@@ -964,6 +979,7 @@
         case kCHUNKY_WRITES:       R__MNM ( &p->chunky_writes );
         case kNO_ATOMIC_OPEN:      R__BOO ( &p->bNo_atomic_open );
         case kLOG_FACILITY:        R__MNM ( &p->log_facility );
+        case kLOG_LEVEL:           R__MNM ( &p->pLog_Level );
         case kLOG_LOGIN:           R__PTR ( &p->pLog_login );
         case kMAXBULLS:            R__INT ( &p->nMaxBulls );
         case kXTND_XMIT:           R__BOO ( &p->bXtnd_Xmit );
diff -ur qpopper4.0.8/popper/pop_log.c qpopper4.0.8-log/popper/pop_log.c
--- qpopper4.0.8/popper/pop_log.c	Mon Apr 25 23:14:39 2005
+++ qpopper4.0.8-log/popper/pop_log.c	Thu May 26 20:04:13 2005
@@ -142,7 +142,8 @@
         fflush  ( p->trace );
     }
     else {
-        syslog ( (int) loglev, "%s", msgbuf );
+	if(!p || p->debug || !p->pLog_Level || p->pLog_Level >= loglev || !loglev ) 	
+           syslog ( (int) loglev, "%s", msgbuf );
     }
     
     if ( iChunk == -1 ) {
diff -ur qpopper4.0.8/popper/popper.h qpopper4.0.8-log/popper/popper.h
--- qpopper4.0.8/popper/popper.h	Thu Apr 28 18:46:18 2005
+++ qpopper4.0.8-log/popper/popper.h	Thu May 26 20:20:36 2005
@@ -701,6 +701,7 @@
     chunky_type        chunky_writes;           /* When to pool network writes */
     BOOL               bNo_atomic_open;         /* open() isn't automic. */
     log_facility_type   log_facility;           /* Which log facility to use */
+    log_level           pLog_Level;             /* which loglevels get logged when not in debug mode*/
     char               *pLog_login;             /* String to use when logging log-ins */
     BOOL                bXtnd_Xmit;             /* Allow XTND XMIT */
 #if 0 /* can't use this until we have a way to call pam_close_session with privs */
